<template>
  <single-pane capt="Состав карточки участника" class="page-card-constructor">
    <ob-table
      :items="gridData"
      :columns="columnsObTable"
      :functionalPanel="true"
      :show-add-button="true"
      @select="openPopup"
      @add="openAddPopup"
      ref="obTable"
    />
    <SB-card-contructor-popup
      ref="CardContructorPopup"
      @saved="fetchFields({ update: true })"
    />
  </single-pane>
</template>

<script>
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import ObTable from 'common-components/src/obComponents/obTable';
import SBCardContructorPopup from './modal/CardContructorPopup';
import api from '@/api';
import moment from 'moment';

export default {
  name: 'FieldConstructor',
  components: {
    ObTable,
    SinglePane,
    SBCardContructorPopup
  },
  data() {
    return {
      gridData: [],
      rolesList: [],
      cardColumns: [
        {
          title: 'Наименование поля',
          field: 'title',
          fixed: true
        },
        {
          title: 'Страна',
          field: 'countries',
          calculateCellValue(data) {
            if (data.countries.length) {
              return data.countries.map(i => i.name).join(', ');
            }
            return '';
          }
        },
        {
          title: 'Форма организации',
          field: 'legal_entity_title',
          calculateCellValue(data) {
            if (data.legal_entity_type && data.legal_entity_type.length) {
              return data.legal_entity_type.map(item => item.title).join(', ');
            }
            return '';
          }
        },
        {
          title: 'Роль',
          field: 'participant_role_codes',
          calculateCellValue: (data) => {
            if (data.participant_role_codes.length) {
              return data.participant_role_codes
                .map(code => this.getRoleTitle(code))
                .join(', ');
            }
            return '';
          }
        },
        {
          title: 'Статус',
          field: 'is_active',
          items: ['Активна', 'Неактивна'],
          calculateCellValue(data) {
            return data.is_active ? 'Активна' : 'Неактивна';
          }
        },
        {
          title: 'Дата',
          field: 'created_at',
          sortOrder: 'desc',
          width: 110,
          calculateCellValue(data) {
            return data.created_at
              ? moment(data.created_at).format('DD.MM.YYYY')
              : '';
          }
        }
      ],
      columnsObTable: [
        {
          title: 'Наименование поля',
          key: 'title',
          fixed: true
        },
        {
          title: 'Страна',
          key: 'countries',
          html: function(data) {
            if (data.countries.length) {
              return data.countries.map(i => i.name).join(', ');
            }
            return '';
          }
        },
        {
          title: 'Форма организации',
          key: 'legal_entity_title',
          html: function(data) {
            if (data.legal_entity_type && data.legal_entity_type.length) {
              return data.legal_entity_type.map(item => item.title).join(', ');
            }
            return '';
          }
        },
        {
          title: 'Роль',
          key: 'participant_role_codes',
          html: (data) => {
            if (data.participant_role_codes.length) {
              return data.participant_role_codes
                .map(code => this.getRoleTitle(code))
                .join(', ');
            }
            return '';
          }
        },
        {
          title: 'Статус',
          key: 'is_active',
          html: function(data) {
            return data.is_active ? 'Активна' : 'Неактивна';
          }
        },
        {
          title: 'Дата',
          key: 'created_at',
          width: 110,
          html: function(data) {
            return data.created_at
              ? moment(data.created_at).format('DD.MM.YYYY')
              : '';
          }
        }
      ]
    };
  },
  methods: {
    openAddPopup() {
      this.$refs.CardContructorPopup.open();
    },
    onLoad() {},
    updateFilter() {},
    async openPopup(data) {
      try {
        const res = await api.cardField.get(data.uuid);
        const risks_list = await api.card.getRisk(data.uuid);
        res.uuid = data.uuid;
        this.$refs.CardContructorPopup.open({ ...res, risks_list });
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    async fetchFields({ update = false } = {}) {
      try {
        this.gridData = await api.cardField.fetch();
        if (!update) {
          let roles = await api.cardField.getRoles();
          this.rolesList = roles.content;
        }
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    getRoleTitle(code) {
      let role = this.rolesList.find(item => item.code === code);
      return role ? role.title : '';
    }
  },
  mounted() {
    this.fetchFields();
  }
};
</script>

